	
	' !!NOTE!!
	' YOU MUST HAVE WRITE PERMISSIONS TO THE LOCATIONS DEFINED BELOW FOR THE TEMP,DEBUG, AND PRICE FILE
	' YOU MUST UPDATE THE 'strRootFolder' VARIABLE TO POINT TO THE ROOT FOLDER OF YOUR MAGIC ALBUM APPLICATION INSTALL
	' !!NOTE!!
	
	Dim strDebugMode,strTempFile,strDebugFile,strPriceFile,intCardCount,strScriptVersion,strRootFolder
	strScriptVersion = "1.0"
	intCardCount = 0
	strDebugMode = "off"		'off,prompt,debug
	strRootFolder = "C:\Magic Album\"
	If NOT Right(strRootFolder,1) = "\" Then : strRootFolder = strRootFolder & "\" : End If
	strTempFile = strRootFolder & "fmcwebdata.tmp"
	strDebugFile = strRootFolder & "fmcdebug.tmp"
	strPriceFile = strRootFolder & "findmagiccards.txt"
	CollectCardInformation "yes",strPriceFile,"nonfoil","English"
	WriteLog strPriceFile,":cardcount:" & vbTab & intCardCount,"no"
	Select Case LCase(strDebugMode)
		Case "off"
			WriteLog strTempFile,"","delete"
			WriteLog strDebugFile,"","delete"
		Case "prompt"
			MsgBox "Complete",VbOkOnly,"Complete"
			WriteLog strTempFile,"","delete"
			WriteLog strDebugFile,"","delete"
		Case "debug"
			MsgBox "Complete",VbOkOnly,"Complete"
			WriteLog strTempFile,"","delete"
			WriteLog strDebugFile,"","delete"
		Case Else
			WriteLog strTempFile,"","delete"
			WriteLog strDebugFile,"","delete"
	End Select
	
	Function HTTPDownload(myURL, strFile)
		On Error Resume Next
		Dim i, objFile, objFSO, objHTTP, strResults
		strResults = "failed"
		Const ForReading = 1, ForWriting = 2, ForAppending = 8
		Set objFSO = CreateObject( "Scripting.FileSystemObject" )
		Set objFile = objFSO.OpenTextFile( strFile, ForWriting, True )
	    	Set objHTTP = CreateObject( "WinHttp.WinHttpRequest.5.1" )
		objHTTP.Open "GET", myURL, False
		objHTTP.Send
		For i = 1 To LenB( objHTTP.ResponseBody )
			objFile.Write Chr( AscB( MidB( objHTTP.ResponseBody, i, 1 ) ) )
		Next
		objFile.Close( )
		strResults = "success"
		HTTPDownload = strResults
	End Function
	
	Sub WriteLog(strLogFile,strDataToWrite,strRecreate)
		On Error Resume Next
		Dim objFileSys,objFileOpenForAppending
		Set objFileSys = CreateObject("Scripting.FileSystemObject")
		If LCase(strRecreate) = "delete" Then
			If objFileSys.FileExists(strLogFile) Then
				objFileSys.DeleteFile strLogFile,True
			End If
		Else
			If Not (objFileSys.FileExists(strLogFile)) Then : objFileSys.CreateTextFile strLogFile : End If
			If (LCase(strRecreate) = "yes") Then : objFileSys.CreateTextFile strLogFile : End If
			Set objFileOpenForAppending = objFileSys.OpenTextFile(strLogFile,8)
			objFileOpenForAppending.WriteLine strDataToWrite
			objFileOpenForAppending.Close
			Set objFileOpenForReading = Nothing
		End If
	End Sub
	
	Function CorrectCardNames(strCardNameToCorrect)
		On Error Resume Next
		Dim strResults
		strResults = ""
		Select Case strCardNameToCorrect
			Case Else : strResults = strCardNameToCorrect
		End Select
		If strResults = "" Then : strResults = strCardNameToCorrect : End If
		CorrectCapeFearGamesCardNames = strResults
	End Function

	Sub CollectCardInformation(strRecreateSaveFile,strSaveFile,strFoilOrNonFoil,strCardLanguage)
		On Error Resume Next
		Dim strSiteURLHeader,strSiteURLFooter,intNewArraySize,strResults,objFileSys,objFileOpenForReading,strCurrentReadLine,strCardBlock,strCardBlockOpenString,strCardBlockEndString,strLocatedCardName,strLocatedCardValue,strCardVersion,strCloseBlockFound,strOpenBlockFound,intLocatedCardValueLength
		Dim ArrPageCount(),ArrSetName(),ArrSetURL()
		strSiteURLHeader = "http://bidwicket.com/Category/Collectible_Card_Games/Magic_the_Gathering/Singles/"
		intNewArraySize = 0
		strResults = "unknown"
		strCardBlock = ""
		strCardBlockOpenString = "<TD colspan=6 align=left valign=top>"
		'strCardBlockEndString = "<TR bgcolor='#F0F0F0'><TD align=right colspan=9>"
		strCardBlockEndString = "<TD colspan=3 align=right valign=top>"
		strLocatedCardName = ""
		strLocatedCardValue = ""
		strCardVersion = "0"
		
		'write log start time
		If (LCase(strRecreateSaveFile) = "yes") Then : WriteLog strSaveFile,"collectcapefeargamesnonfoil start-time: [" & date() & "@" & time() & "]","yes" : else : WriteLog strSaveFile,"collectcapefeargamesnonfoil start-time: [" & date() & "@" & time() & "]","no" : End If
		
		'generate set array information

		'--innistrad block
		Redim Preserve ArrPageCount(intNewArraySize) : Redim Preserve ArrSetName(intNewArraySize) : Redim Preserve ArrSetURL(intNewArraySize)
		ArrPageCount(intNewArraySize) = 1 : ArrSetName(intNewArraySize) = "Innistrad" : ArrSetURL(intNewArraySize) = "Innistrad" : intNewArraySize = UBound(arrPageCount) + 1

		'--scars of mirrodin block
		Redim Preserve ArrPageCount(intNewArraySize) : Redim Preserve ArrSetName(intNewArraySize) : Redim Preserve ArrSetURL(intNewArraySize)
		ArrPageCount(intNewArraySize) = 1 : ArrSetName(intNewArraySize) = "New Phyrexia" : ArrSetURL(intNewArraySize) = "New_Phyrexia" : intNewArraySize = UBound(arrPageCount) + 1
		Redim Preserve ArrPageCount(intNewArraySize) : Redim Preserve ArrSetName(intNewArraySize) : Redim Preserve ArrSetURL(intNewArraySize)
		ArrPageCount(intNewArraySize) = 1 : ArrSetName(intNewArraySize) = "Mirrodin Besieged" : ArrSetURL(intNewArraySize) = "Mirrodin_Besieged" : intNewArraySize = UBound(arrPageCount) + 1
		Redim Preserve ArrPageCount(intNewArraySize) : Redim Preserve ArrSetName(intNewArraySize) : Redim Preserve ArrSetURL(intNewArraySize)
		ArrPageCount(intNewArraySize) = 1 : ArrSetName(intNewArraySize) = "Scars of Mirrodin" : ArrSetURL(intNewArraySize) = "Scars_of_Mirrodin" : intNewArraySize = UBound(arrPageCount) + 1

		'--zendikar block
		Redim Preserve ArrPageCount(intNewArraySize) : Redim Preserve ArrSetName(intNewArraySize) : Redim Preserve ArrSetURL(intNewArraySize)
		ArrPageCount(intNewArraySize) = 1 : ArrSetName(intNewArraySize) = "Rise of the Eldrazi" : ArrSetURL(intNewArraySize) = "Rise_of_the_Eldrazi" : intNewArraySize = UBound(arrPageCount) + 1
		Redim Preserve ArrPageCount(intNewArraySize) : Redim Preserve ArrSetName(intNewArraySize) : Redim Preserve ArrSetURL(intNewArraySize)
		ArrPageCount(intNewArraySize) = 1 : ArrSetName(intNewArraySize) = "Worldwake" : ArrSetURL(intNewArraySize) = "Worldwake" : intNewArraySize = UBound(arrPageCount) + 1
		Redim Preserve ArrPageCount(intNewArraySize) : Redim Preserve ArrSetName(intNewArraySize) : Redim Preserve ArrSetURL(intNewArraySize)
		ArrPageCount(intNewArraySize) = 1 : ArrSetName(intNewArraySize) = "Zendikar" : ArrSetURL(intNewArraySize) = "Zendikar" : intNewArraySize = UBound(arrPageCount) + 1
		
		'--core sets
		Redim Preserve ArrPageCount(intNewArraySize) : Redim Preserve ArrSetName(intNewArraySize) : Redim Preserve ArrSetURL(intNewArraySize)
		ArrPageCount(intNewArraySize) = 1 : ArrSetName(intNewArraySize) = "Magic 2012" : ArrSetURL(intNewArraySize) = "Magic_2012_Core_Set" : intNewArraySize = UBound(arrPageCount) + 1
		Redim Preserve ArrPageCount(intNewArraySize) : Redim Preserve ArrSetName(intNewArraySize) : Redim Preserve ArrSetURL(intNewArraySize)
		ArrPageCount(intNewArraySize) = 1 : ArrSetName(intNewArraySize) = "Magic 2011" : ArrSetURL(intNewArraySize) = "Magic_2011_Core_Set" : intNewArraySize = UBound(arrPageCount) + 1
		Redim Preserve ArrPageCount(intNewArraySize) : Redim Preserve ArrSetName(intNewArraySize) : Redim Preserve ArrSetURL(intNewArraySize)
		ArrPageCount(intNewArraySize) = 1 : ArrSetName(intNewArraySize) = "Magic 2010" : ArrSetURL(intNewArraySize) = "Magic_2010_Core_Set" : intNewArraySize = UBound(arrPageCount) + 1
		
		'loop through array of set information and parse set accordingly
		For i = 0 to UBound(ArrPageCount)
			For j = 0 to ArrPageCount(i)
				strCloseBlockFound = False
				strOpenBlockFound = False

				'download each page of data containing set information from pricing web site
				If j = UBound(ArrPageCount) - 1 Then
					strResults = HTTPDownload(strSiteURLHeader & ArrSetURL(i) & ".html",strTempFile)
				Else
					strResults = HTTPDownload(strSiteURLHeader & ArrSetURL(i) & ".html",strTempFile)
				End If

				'parse collected data if download was a success
				If (LCase(strResults) = "success") Then

					'display debug information
					If LCase(strDebugMode) = "debug" Then
						MsgBox "Please Verify Downloaded Page Data",VbOkOnly,"Debug"
					End If

					Set objFileSys = CreateObject("Scripting.FileSystemObject")
					Set objFileOpenForReading = objFileSys.OpenTextFile(strTempFile,1)
					Do While objFileOpenForReading.AtEndOfStream <> True
						'read in current file linie
						strCurrentReadLine = objFileOpenForReading.ReadLine

						'locate card pricing block opening string in collected data
						If InStr(strCurrentReadLine,strCardBlockOpenString) Then : strOpenBlockFound = True : End If


						'append read in line to card block code IF open block string found
						If strOpenBlockFound = True Then
							strCardBlock = strCardBlock & strCurrentReadLine
	
							'locate card pricing block closing string in collected data
							If InStr(strCurrentReadLine,strCardBlockEndString) Then : strCloseBlockFound = True : End If
						End If

						'process card pricing block
						If strCloseBlockFound = True Then

							'write/display debug information out
							If LCase(strDebugMode) = "debug" Then
								WriteLog strDebugFile,strCardBlock,"yes"
								MsgBox "Please Verify Card Block Information",VBOkOnly,"Verify"
							End If

							'process card block for card name
							colCurrentCardBlockSplitOne = Split(strCardBlock,"</a>")
							If UBound(colCurrentCardBlockSplitOne) > 1 Then
								colCurrentCardBlockSplitTwo = Split(colCurrentCardBlockSplitOne(0),">")
								strLocatedCardName = Trim(colCurrentCardBlockSplitTwo(UBound(colCurrentCardBlockSplitTwo)))
								colCurrentCardBlockSplitOne = Split(strLocatedCardName,"(")
								strLocatedCardName = Trim(colCurrentCardBlockSplitOne(0))
								If InStr(strLocatedCardName,"=") Then : strLocatedCardName = "" : End If
							End If

							'process card block for card price
							colCurrentCardBlockSplitOne = Split(strCardBlock,"</a>")
							If UBound(colCurrentCardBlockSplitOne) > 0 Then
								colCurrentCardBlockSplitTwo = Split(colCurrentCardBlockSplitOne(1),"$")
								strLocatedCardValue = Trim(colCurrentCardBlockSplitTwo(UBound(colCurrentCardBlockSplitTwo)))
								If InStr(strLocatedCardValue,"$") Then
									intLocatedCardValueLength = Len(strLocatedCardValue)
									strLocatedCardValue = Right(strLocatedCardValue,intLocatedCardValueLength - 1)
								End If
								If InStr(strLocatedCardValue,"=") Then : strLocatedCardValue = "" : End If
							End If

							'display debug information
							If LCase(strDebugMode) ="debug" Then
								MsgBox "Name: " & strLocatedCardName & VBCrLf & "Price: " & strLocatedCardValue,VBOkOnly,"Debug"
							End If

							'write collected card data to file
							If NOT strLocatedCardName = "" Then
								strLocatedCardName = CorrectCardName(strLocatedCardName)
								If NOT strLocatedCardValue = "" Then
									WriteLog strSaveFile,strLocatedCardName & vbtab & strLocatedCardValue & vbtab & ArrSetName(i) & vbtab & strCardLanguage & vbtab & strCardVersion & vbtab & strFoilOrNonFoil,"no"
									intCardCount = intCardCount + 1
								End If
							End If

							'clear current card block for next cards information
							strOpenBlockFound = False
							strCloseBlockFound = False
							strCardBlock = ""
							strLocatedCardName = ""
						End If

					Loop
					objFileOpenForReading.Close
					Set objFileSys = Nothing
				End If
			Next
		Next
		
		'write log end time
		WriteLog strSaveFile,"collectcapefeargamesnonfoil end-time: [" & date() & "@" & time() & "]","no"
	End Sub
